import java.util.*;

interface MyInterface {
  int foo(int value);
}

public class Sample {
  public static int someFunction(MyInterface inst) {
    return inst.foo(2);
  }
  
	public static void main(String[] args) {
	  //someFunction is already a higher order function since it can take a labmda.
	  //labmda can be used anywhere a functional (single abstract method) interface is used.
	  
	  //so instead of
	  System.out.println(someFunction(new MyInterface() {
	    public int foo(int input) {
	      return input * 2;
	    }
	  }));
	  
	  //we can do
	  System.out.println(someFunction(e -> e * 2));
  }
}
